import 'package:dio/dio.dart';

import '../../../matule_query.dart';

class Client extends Repository {
  @override
  String get apiUrl => "https://api.matule.ru/api";

  AuthModel? _authModel;

  Options get options => Options(
    headers: (_authModel != null)
        ? {"Authorization": "Bearer ${_authModel!.token}"}
        : null,
  );

  @override
  Future<AuthModel> login(String identity, String password) async {
    Response response = await dio.post(
      "$apiUrl/collections/users/auth-with-password",
      data: {"identity": identity, "password": password},
      options: options,
    );
    _authModel = AuthModel.fromJSON(response.data);
    return _authModel!;
  }
}
