import 'package:matule_query/matule_query.dart';

class BaseUseCase {
  final Function() startLoading;
  final Function() endLoading;
  final Function(Object?) onResponse;
  final Function(Exception) onError;
  final QueryHelper helper;
  final Client client = Client();

  BaseUseCase({
    required this.startLoading,
    required this.endLoading,
    required this.onResponse,
    required this.onError,
  }) : helper = QueryHelper(startLoading: startLoading, endLoading: endLoading);

  Future<void> login(String identity, String password) async {
    await helper.request(
      () => client.login(identity, password),
      onResponse,
      onError,
    );
  }
}
